/* 
dd improved 
Copyright 2006 Ludwig Zeller, Martin Rumori

Usage: program file offset length 

##################################################
# This file is part of timeslots.
# timeslots is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
# timeslots is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
##################################################

*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

int main ( int argc, char *argv[] )
{
    FILE *fp;
    int length = atoi(argv[3]);
    int read;
    char *pixelRow = malloc(length);

    if (argc < 4)
      {
	fprintf(stderr, "usage: %s file offset length", argv[0]);
	exit(EXIT_FAILURE);
      }

    if ((fp = fopen(argv[1], "rb")) == NULL)
      {
	perror("file open failed");
	exit(EXIT_FAILURE);
      }

    if (fseek(fp, atol(argv[2]), SEEK_SET))
      {
	perror("impossible to seek");
	exit(EXIT_FAILURE);
      }

    read = fread(pixelRow, 1, length, fp);
    fclose(fp);   
    fwrite(pixelRow, 1, read, stdout);

    free(pixelRow);

    return EXIT_SUCCESS;
}
