#!/bin/bash
#
# enumerator.sh
#
# Copyright 2006 Ludwig Zeller
#
# Usage: enumerator.sh [-p preview mode] [-v verbose] [-e extension] [-n filebody] Reads from STDIN, if no Arguments are specified.
#
##################################################
# This file is part of timeslots.
# timeslots is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
# timeslots is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
##################################################

VERBOSE=0
PREVIEW=0
EXT=.rgb
NAME=enum
ZERO=5

while getopts  "pve:n:0:" o
do		
	case "$o" in
		p)	PREVIEW=1;VERBOSE=1;;
		v)	VERBOSE=1;;
		e)	EXT="$OPTARG";;
		n)	NAME="$OPTARG";;
		0)	ZERO="$OPTARG";;
		
		[?])	echo >&2 "Usage:  enumerator.sh [-p preview mode] [-v verbose] [-e extension] [-n filebody] Reads from STDIN, if no Arguments are specified."
			exit 1;;
	esac
done
shift $(($OPTIND-1))				# this is to point to the actual argument FILEBODY -> $1


function main ()
{

	if [ $VERBOSE -eq 1 ]; then
		echo >&2 "mv $FILE `dirname $FILE`/`printf "%s%0${ZERO}d%s" $NAME $CURRENT $EXT`"
	fi	
	if [ $PREVIEW -eq 0 ]; then
		mv $FILE `dirname $FILE`/`printf "%s%0${ZERO}d%s" $NAME $CURRENT $EXT`
	fi
	CURRENT=$(($CURRENT+1))
}

CURRENT=0

if [ -n "$*" ]; then						# no arguments
	for FILE in $*; do
		main;		
	done
else								# read stdin
	while read FILE; do
		if [ $FILE ]; then				# line has to be non empty
			main;
		fi		
	done	
fi





